// vim:syntax=ragel

#include <stdio.h>
#include "config.h"
#include "machine.h"

#ifndef SIZEOF_FLOAT_TYPE
# error "SIZEOF_FLOAT_TYPE not defined."
#endif

#ifndef SIZEOF_INT_TYPE
# error "SIZEOF_INT_TYPE not defined."
#endif

%%{
    machine JSON_number;
    alphtype char;
    # we could be much less specific here.. but i guess its ok to ensure the 
    # format, not correctness in the sense of sscanf 
    # 
    action break {
	fbreak;
    }

    myspace = [ \n\r\t];
    end = [\]},:]|myspace;
    exp = [eE] >{d = 1;}. [+\-]? . digit+ . (end >break)?;
    float = '.' >{d = 1;} . digit+ . (end >break | exp)?;
    main := '-' ? . (('0' | ([1-9] . digit*)) . (end >break | float | exp)?) | float; 
}%%

static char *_parse_JSON_number_utf8(char *p, char *pe, struct parser_state *state) {
    char *i = p;
    int cs;
    INT_TYPE d = 0;
    FLOAT_TYPE f;

    %% write data;

    %% write init;
    %% write exec;

    if (cs >= JSON_number_first_final) {
	
		if (!state->validate) {
			char temp = *p;
			*p = 0;

			if (d) {
#if SIZEOF_FLOAT_TYPE == SIZEOF_FLOAT
				if (1 != sscanf(i, "%f", &f)) {
#elif SIZEOF_FLOAT_TYPE == SIZEOF_DOUBLE
				if (1 != sscanf(i, "%lf", &f)) {
#elif SIZEOF_FLOAT_TYPE == SIZEOF_LONG_DOUBLE
				if (1 != sscanf(i, "%Lf", &f)) {
#else
# error "Unknown size of FLOAT_TYPE"
#endif
					*p = temp;

					push_int((INT_TYPE)i);
					return NULL;
				}
				push_float(f);
			} else {
#if SIZEOF_INT_TYPE == SIZEOF_LONG_INT
				if (1 != sscanf(i, "%ld", &d)) {
#elif SIZEOF_INT_TYPE == SIZEOF_INT
				if (1 != sscanf(i, "%d", &d)) {
#elif SIZEOF_INT_TYPE == SIZEOF_LONG_LONG
				if (1 != sscanf(i, "%Ld", &d)) {
#else
# error "Unknown size of INT_TYPE"
#endif
					*p = temp;

					push_int((INT_TYPE)i);
					return NULL;
				}
				push_int(d);
			}

			*p = temp;
		}

		return p;
    }

    push_int((INT_TYPE)p);
    return NULL;
}

